#include "KMotionDef.h"
#include "cyclone.h"
#include "KflopToKMotionCNCFunctions.c"

enum mesErr {OK, NOTHOMED, TCFAIL};

// this function checks lathe is fully initialised and ready to run parts, otherwise it commands a halt and warns USER_INPUT_MODE
// Checks include Homed, TC initialised
main()
{
	int MachineOK = OK;	// we'll start with a 0
	
	if(!ReadBit(XHOMED))	// if X axis is not homed, we can't start
	{
		DoPC(PC_COMM_HALT);	// we'll tell KMotionCNC to Halt
		MsgBox("Cycle Start inhibited - X Axis not homed",MB_OK|MB_ICONEXCLAMATION);
	}
	if(!ReadBit(ZHOMED))	// if Z axis is not homed, we can't start
	{
		DoPC(PC_COMM_HALT);	// we'll tell KMotionCNC to Halt
		MsgBox("Cycle Start inhibited - Z Axis not homed",MB_OK|MB_ICONEXCLAMATION);
	}
	if(ReadBit(INIT))	// if INIT is still set, the TC is not ready
	{
		DoPC(PC_COMM_HALT);	// we'll tell KMotionCNC to Halt
		MsgBox("Cycle Start inhibited - ToolChanger not initialised",MB_YESNO|MB_ICONEXCLAMATION);
	}
	if(ReadBit(LUBELOW))
	{
		MsgBox("Lubrication Low. Refill",MB_OK|MB_ICONEXCLAMATION);
	}
		
}
