#include "KMotionDef.h"
#include "Cyclone.h"
#include "Cyclone_EStopMonitor.c"
#include "Cyclone_ModbusMasterVer1.c"
#include "KflopToKMotionCNCFunctions.c"
#include "Cyclone_CSSJog.c"
#include "AdjustSoftLimits.c"


// X-axis on channel 0
// Z-aixs on channel 1
// Spindle on channel 2

int main() 
{
	// Start Modbus stuff
	ModbusMaster_Init();
	int reportsecs=10;
	double starttime;;
	double MonitorStartTime=0;	// start of most recent monitor cycle
	double MonitorCycleTime=0;	// seconds to call all commands in Monitor list
	int TallyConnections=0;	// Number of times Connecion list has been sent
	int TallyCommands=0;	// Commands since connection
	int TallyRetries=0;	// Retries since connection
	starttime=Time_sec();
	TallyCommands=ModbusMaster_TallyCommands;
	// End Modbus stuff
	
	ClearBit(SERVOENABLE);	// Disable all outputs (mostly in case we're recoving from some form of crash, but also to guarantee outputs are in a known state)
	ClearBit(TCALLOW);		
	ClearBit(SERVORESET);
	ClearBit(COOLANT);
	ClearBit(SPDLFOR);
	ClearBit(SPDLREV);
	
	ClearBit(INHOMING);		// used to avoid estop during axis homing (axis gets diabled during homing)
	ClearBit(SYSTEMOK);
	ClearBit(TCACTIVE);
	ClearBit(JOGALLOWED);
	ClearBit(ESTOPHANDLED);
	
	SetBit(INIT);			// set this so we know we're initialising system
	
	//int estop,zready,xready;
	//int *SpindleOn = &persist.UserData[3];	// Place to remember whether spindle is on or off
	//*SpindleOn = FALSE;						// Spindle should be of during init, so set to false so our soft e-stop checking works
	SetBit(SYSTEMOK);
	
	
	ch0->InputMode=ENCODER_MODE;
	ch0->OutputMode=DAC_SERVO_MODE;
	ch0->Vel=400000;
	ch0->Accel=2000000;
	ch0->Jerk=4000000;
	ch0->P=2.2;
	ch0->I=0.015;
	ch0->D=3.5;
	ch0->FFAccel=0;
	ch0->FFVel=0;
	ch0->MaxI=2048;
	ch0->MaxErr=1e+006;
	ch0->MaxOutput=2048;
	ch0->DeadBandGain=1;
	ch0->DeadBandRange=0;
	ch0->InputChan0=0;
	ch0->InputChan1=0;
	ch0->OutputChan0=0;
	ch0->OutputChan1=1;
	ch0->MasterAxis=-1;
	ch0->LimitSwitchOptions=0x0;
	ch0->InputGain0=1;
	ch0->InputGain1=1;
	ch0->InputOffset0=0;
	ch0->InputOffset1=0;
	ch0->OutputGain=1;
	ch0->OutputOffset=0;
	ch0->SlaveGain=1;
	ch0->BacklashMode=BACKLASH_OFF;
	ch0->BacklashAmount=0;
	ch0->BacklashRate=0;
	ch0->invDistPerCycle=1;
	ch0->Lead=0;
	ch0->MaxFollowingError=50;
	ch0->StepperAmplitude=20;

	ch0->iir[0].B0=1;
	ch0->iir[0].B1=0;
	ch0->iir[0].B2=0;
	ch0->iir[0].A1=0;
	ch0->iir[0].A2=0;

	ch0->iir[1].B0=1;
	ch0->iir[1].B1=0;
	ch0->iir[1].B2=0;
	ch0->iir[1].A1=0;
	ch0->iir[1].A2=0;

	ch0->iir[2].B0=1;
	ch0->iir[2].B1=0;
	ch0->iir[2].B2=0;
	ch0->iir[2].A1=0;
	ch0->iir[2].A2=0;
    

	ch1->InputMode=ENCODER_MODE;
	ch1->OutputMode=DAC_SERVO_MODE;
	ch1->Vel=400000;
	ch1->Accel=2000000;
	ch1->Jerk=4000000;
	ch1->P=2.5;
	ch1->I=0.02;
	ch1->D=8;
	ch1->FFAccel=0;
	ch1->FFVel=0;
	ch1->MaxI=2048;
	ch1->MaxErr=1e+006;
	ch1->MaxOutput=2048;
	ch1->DeadBandGain=1;
	ch1->DeadBandRange=0;
	ch1->InputChan0=1;
	ch1->InputChan1=1;
	ch1->OutputChan0=1;
	ch1->OutputChan1=3;
	ch1->MasterAxis=-1;
	ch1->LimitSwitchOptions=0x0;
	ch1->InputGain0=1;
	ch1->InputGain1=1;
	ch1->InputOffset0=0;
	ch1->InputOffset1=0;
	ch1->OutputGain=1;
	ch1->OutputOffset=0;
	ch1->SlaveGain=1;
	ch1->BacklashMode=BACKLASH_OFF;
	ch1->BacklashAmount=0;
	ch1->BacklashRate=0;
	ch1->invDistPerCycle=1;
	ch1->Lead=0;
	ch1->MaxFollowingError=50;
	ch1->StepperAmplitude=20;

	ch1->iir[0].B0=1;
	ch1->iir[0].B1=0;
	ch1->iir[0].B2=0;
	ch1->iir[0].A1=0;
	ch1->iir[0].A2=0;

	ch1->iir[1].B0=1;
	ch1->iir[1].B1=0;
	ch1->iir[1].B2=0;
	ch1->iir[1].A1=0;
	ch1->iir[1].A2=0;

	ch1->iir[2].B0=1;
	ch1->iir[2].B1=0;
	ch1->iir[2].B2=0;
	ch1->iir[2].A1=0;
	ch1->iir[2].A2=0;
    

	ch2->InputMode=ENCODER_MODE;
	ch2->OutputMode=NO_OUTPUT_MODE;
	ch2->Vel=166666;
	ch2->Accel=40000;
	ch2->Jerk=4e+006;
	ch2->P=0.01;
	ch2->I=0;
	ch2->D=0;
	ch2->FFAccel=0;
	ch2->FFVel=0;
	ch2->MaxI=200;
	ch2->MaxErr=1e+006;
	ch2->MaxOutput=2048;
	ch2->DeadBandGain=1;
	ch2->DeadBandRange=0;
	ch2->InputChan0=2;
	ch2->InputChan1=0;
	ch2->OutputChan0=2;
	ch2->OutputChan1=0;
	ch2->MasterAxis=-1;
	ch2->LimitSwitchOptions=0x0;
	ch2->InputGain0=1;
	ch2->InputGain1=1;
	ch2->InputOffset0=0;
	ch2->InputOffset1=0;
	ch2->OutputGain=1;
	ch2->OutputOffset=0;
	ch2->SlaveGain=1;
	ch2->BacklashMode=BACKLASH_OFF;
	ch2->BacklashAmount=0;
	ch2->BacklashRate=0;
	ch2->invDistPerCycle=1;
	ch2->Lead=0;
	ch2->MaxFollowingError=2000000;	// divide by 8000 for revolutions
	ch2->StepperAmplitude=20;

	ch2->iir[0].B0=1;
	ch2->iir[0].B1=0;
	ch2->iir[0].B2=0;
	ch2->iir[0].A1=0;
	ch2->iir[0].A2=0;

	ch2->iir[1].B0=1;
	ch2->iir[1].B1=0;
	ch2->iir[1].B2=0;
	ch2->iir[1].A1=0;
	ch2->iir[1].A2=0;

	ch2->iir[2].B0=0.000769;
	ch2->iir[2].B1=0.001538;
	ch2->iir[2].B2=0.000769;
	ch2->iir[2].A1=1.92081;
	ch2->iir[2].A2=-0.923885;
	
	DefineCoordSystem(0,-1,1,-1);

	//double delayT = 0;
	int initDelay = 0;
	//int tDelay = 10;
	
	// we need to trigger the servo reset output, then wait for both drives to signal ready
	// if either of the servos aren't ready, we need to disable them, then trigger the reset
	if(!ReadBit(XREADY) || !ReadBit(ZREADY)) {
		printf("X or Z Not ready\n");
		ClearBit(SERVOENABLE);		// this should be clear anyway, but we need to be 100% sure or the reset will fail
		SetBit(SERVORESET);
		printf("SERVOENABLE unset, SERVORESET set\n");
		double initTimeOut = Time_sec() + 2;
		int readyTest = 0;
		while(readyTest = 0)
		{
			if(ReadBit(XREADY) && ReadBit(ZREADY))	// if ready signals go high, we're good to go
				readyTest = 1;
				printf("X and Z now ready\n");
			if(initTimeOut < Time_sec())			// have we timed out?
			{									// Ask if we want to retry
				printf("Timed Out\n");
				int Answer = MsgBox("Servo Enable time out. Retry?",MB_YESNO|MB_ICONEXCLAMATION);
				if (Answer == IDYES){			// if yes, we'll toggle the servoreset
					ClearBit(SERVORESET);
					Delay_sec(2);				// with a bit of a delay to give the servo drives to think about it
					SetBit(SERVORESET);			// before we try resetting again...
					initTimeOut = Time_sec() + 2;
				} else {						// else we're going to sit and do nothing
					printf("Servo reset failed and aborted\n");	// once we've printed a message to the console
					MsgBox("Servo enabling failed. Re-run Initialisation to try again",MB_OK|MB_ICONEXCLAMATION);
					for(;;);
				}
			}
		}
		ClearBit(SERVORESET);
		printf("Servos Enabled OK\n");
		printf("SERVORESET unset\n");
	}
	// now servos are ready, we can run a basic eStop check and enable axis
	if (ReadBit(ESTOP)||ReadBit(XREADY)||ReadBit(ZREADY)){
		SetBit(SERVOENABLE);
		printf("SERVOENABLE set\n");
		Delay_sec(0.5);
		EnableAxisDest(0,ch0->Position);
		EnableAxisDest(1,ch1->Position);
		SetBit(JOGALLOWED);		// lets us know we can now move the axis (mainly incase we need to move the turret to allow recovery/indexing)
		printf("All Axis enabled, jogging allowed\n");
	}
	
	// We now need to wait for modbus to come online and confirm tool changer position
	int initTO = Time_sec()+2;	// used for TC timeout monitoring
	int initTCfail = 0;	// we use this if TC initialisation fails first step
	int initTCflag = 0;	// we use this as a flag to monitor TC initialisation at the second step
	double lastSPDLcount = ch2->Position;
	
	// if machine has already been homed, set SoftLimits
	if(ReadBit(XHOMED)){
		ch0->SoftLimitPos = XSOFTPOS;
		ch0->SoftLimitNeg = XSOFTNEG;
	} else {	// else set them very high so we can home succesfully
		ch0->SoftLimitPos = 1e+09;
		ch0->SoftLimitNeg = -1e+09;
	}
	
	// if machine has already been homed, set SoftLimits
	if(ReadBit(ZHOMED)){
		ch0->SoftLimitPos = ZSOFTPOS;
		ch0->SoftLimitNeg = ZSOFTNEG;
	} else {	// else set them very high so we can home succesfully
		ch0->SoftLimitPos = 1e+09;
		ch0->SoftLimitNeg = -1e+09;
	}
	
	for(;;)	// loop forever
	{
		WaitNextTimeSlice();
		ServiceCSS();
		CheckDistToStop(ch0);
		CheckDistToStop(ch1);
		ModbusMaster_Loop();
		if (starttime+reportsecs<Time_sec())	// this loop came from the Modbux example, but we can use it for extra monitoring info
		{
			//printf("\nSeconds: %d\n",reportsecs);
			//printf("ModbusMaster_MonitorCycleTime=%f (%f/s)\n",ModbusMaster_MonitorCycleTime,1.0/ModbusMaster_MonitorCycleTime);
			//printf("ModbusMaster_TallyCommands/s=%0.lf\n",(ModbusMaster_TallyCommands-TallyCommands)/(double)reportsecs);
			//printf("ModbusMaster_TallyConnections=%d\n",ModbusMaster_TallyConnections);
			//printf("ModbusMaster_TallyRetries=%d\n",ModbusMaster_TallyRetries);
			printf("TCPostion=%d\n",persist.UserData[TCPOS]);
			printf("TCDesired=%d\n",persist.UserData[TCDES]);
			double RPM = ((ch2->Position-lastSPDLcount)/8000)/reportsecs;
			printf("RPM:%f\n",RPM);
			starttime=Time_sec();
			TallyCommands=ModbusMaster_TallyCommands;
		}
		
		if(ReadBit(INIT) && !initTCfail){ // if we're initialising, we need to establish TC comms before we can do final enabling
			if((persist.UserData[TCPOS] < 1) || (persist.UserData[TCPOS] > 6)){	// is the TC position valid?
				if((initTO < Time_sec() && initTCfail == 0)){	// if after our time out, we still don't have a valid position, and we've not yet triggered a fail flag
					initTCfail = 1;			// set flag to let us know TC has failed, and display message
					MsgBox("TC failed to Initialise - Invalid position. Use Recover TC to retry initialisation",MB_OK|MB_ICONEXCLAMATION);
				}
			} else {			// else we have a valid position, so we now need to copy the actual position into the desired position uservar, and wait for the TCOK signal
				if(initTCflag == 0){			// have we set the flag yet?
					initTO = Time_sec() + 2;	// if not, reset the timeout
					initTCflag = 1;				// and set the flag
				} else if(initTO < Time_sec()){		// if we time out, send an error message
					initTCfail = 1;					// and set fail flag
					MsgBox("TC failed to Initialise - Valid position, but no OK signal. Use Recover TC to retry initialisation",MB_OK|MB_ICONEXCLAMATION);
				}
				persist.UserData[TCDES] = persist.UserData[TCPOS];	// once TCPOS is in valid range, set TCDES to match
				if(ReadBit(TCOK)){		// TCOK should now set to indicate TC established, so we can clear INIT
					ClearBit(INIT);
				}
			}
		}
		estop_test();		// monitors for e-stop conditions, and kills everything if something fails
		
		
		// **** Start Spindle Control ****
		// As the standard channel output options can't handle activating outputs depending on
		// direction required, this takes the output from channel 2(Spindle), and activates them
		// accordingly
		if(ch2->Enable)
		{
			if(ch2->Output > 0)
			{
				SetBit(SPDLFOR);
				DAC(2,(int)ch2->Output*-1);
				
			} else {
				ClearBit(SPDLFOR);
			}
			if(ch2->Output < 0)
			{
				SetBit(SPDLREV);
				DAC(2,(int)ch2->Output);
			} else {
				ClearBit(SPDLREV);
			}
		} else {
			ClearBit(SPDLFOR);
			ClearBit(SPDLREV);
		}
		
	}	// end of forever

    return 0;
}
