#include "KMotionDef.h"
#include "Cyclone.h"
//#include "MySpindleDefs.h"

int   *css_mode = &persist.UserData[PC_COMM_CSS_MODE];			// Mode 1=Normal RPM mode. 2=CSS

// desired speed is passed from KMotionCNC in variable KMVAR
// save in user variable STATEVAR whether it was off, CW, or CCW (0,1,-1)
// save in user variable SPEEDVAR the last desired speed

main()
{
	float CmdSpeed, speed = *(float *)&persist.UserData[SPDL_SPEEDVAR];  // value stored is actually a float 
	float LastState = persist.UserData[SPDL_STATEVAR];  // get last state 
	
	if (LastState==-1)  
	{
	
		Jog(SPINDLE,0);
		while (!CheckDone(SPINDLE)) ;
	}
	
	// turn spindle on CW and ramp to new speed
	//ch2->Dest = ch2->Position;
	//SetBit(SPDLFOR);
	printf("Spindle FWD\n");
	if(!ch2->Enable)
		EnableAxis(SPINDLE);
	if (*css_mode != 2)
	{
		// spindle is already on, so ramp to new speed
		if (SPDL_USE_POS_NEG_VOLTAGE)
			Jog(SPINDLE,speed * SPDL_FACTOR * LastState);
		else
			Jog(SPINDLE,speed * SPDL_FACTOR);
		
		// block program until we reach 90% of requested speed
		CmdSpeed = speed * SPDL_FACTOR * LastState;
		while (fast_fabs(chan[SPINDLE].last_vel - CmdSpeed) < 0.1 * fast_fabs(CmdSpeed)) ; 
		
		printf("Jogging Spindle %f counts/sec\n",speed * SPDL_FACTOR);
	}
	persist.UserData[SPDL_STATEVAR] = 1;  // remember we are CW
}

