#include "KMotionDef.h"
#include "cyclone.h"
//#include "MySpindleDefs.h"

int   *css_mode = &persist.UserData[PC_COMM_CSS_MODE];			// Mode 1=Normal RPM mode. 2=CSS

// desired speed is passed from KMotionCNC in variable KMVAR
// save in user variable STATEVAR whether it was off, CW, or CCW (0,1,-1)
// save in user variable SPEEDVAR the last desired speed

main()
{
	float CmdSpeed, speed = *(float *)&persist.UserData[SPDL_KMVAR];  // value stored is actually a float 
	float LastState = persist.UserData[SPDL_STATEVAR];  // get last state 
	
	persist.UserData[SPDL_SPEEDVAR] = persist.UserData[SPDL_KMVAR];  // Always save the last desired speed 
	
	if (LastState==0 || *css_mode == 2)  
	{
		// if spindle is off (or CSS mode) and User Changes the speed 
		// just save the desired speed
		
		return 0;
	}
	
	// spindle is already on, so ramp to new speed
	if (SPDL_USE_POS_NEG_VOLTAGE)
		Jog(SPINDLE,speed * SPDL_FACTOR * LastState);
	else
		Jog(SPINDLE,speed * SPDL_FACTOR);
		
	// block the loop until we reach 90% of requested speed
	CmdSpeed = speed * SPDL_FACTOR * LastState;
	while (fast_fabs(chan[SPINDLE].last_vel - CmdSpeed) < 0.1 * fast_fabs(CmdSpeed)) ; 
	
	printf("Jogging Spindle %f counts/sec\n",speed * SPDL_FACTOR);
}
