#include "KMotionDef.h"

doToolChange()
{
	int curPos = persist.UserData[TCPOS];
	int desPos = persist.UserData[TCDES];
	int newTool = persist.UserData[TCNEW];
	printf("ToolChange.c newTool = %d, TCPOS = %d, TCDES = %d\n", newTool, persist.UserData[TCPOS], persist.UserData[TCDES]);
	//double newTool = persist.UserData[TCXFER];  // value stored is an integer 
	int changeTO = Time_sec() + 2;
	int changeStatus = 0;
	if((newTool<1) || (newTool >6)){
		printf("newTool out of range\n");
		ThreadDone();
	}
	if(newTool != curPos){
		//tools don't match, so we need to do a tool change
		SetBit(TCACTIVE);	// set the tool change flag high so we don't cause an e-stop
		printf("set TCACTIVE\n");
		//if(ReadBit(TCOK)){
		//	printf("TCOK high\n");
		//} else {
		//	printf("TCOK low\n");
		//}
		persist.UserData[TCDES] = newTool;		// update persist variable with new position
		printf("TCDES updated\nToolChange.c newTool = %d, TCPOS = %d, TCDES = %d\n", newTool, persist.UserData[TCPOS], persist.UserData[TCDES]);
		
		while(changeStatus == 0){		// while we've had no reason to exit the loop
			if(!ReadBit(TCOK)){			// has TCOK gone low? It should do as soon as the PLC realises there is requested/actual tool mismatch
				SetBit(TCALLOW);		// Now we can tell the PLC it's ok to Move
				printf("TCOK gone low, TCALLOW set\n");
				changeTO = Time_sec() + 4;	// and reset the timeout (for the actual tool change time out, TCOK not gone low timeout is set above)
				changeStatus = 1;		// if it has, we can quit the loop
			}
			if(changeTO < Time_sec()){	// if we've timed out, message box time
				int Answer = MsgBox("TCOK stuck high. Wait?",MB_YESNO|MB_ICONEXCLAMATION);
				if (Answer == IDYES){			// if yes
					changeTO = Time_sec + 2;	// reset the time out
				} else {						// else we're going to estop everything
					ClearBit(SYSTEMOK);			// by clearing the SYSTEMOK bit (the estop script will handle killing everything)
					printf("TC abandoned by user after TCOK stuck high\n");
					ThreadDone();					// and then we'll kill the thread as nothing more can happen
				}
			}
		}
		while(changeStatus == 1){
			if(ReadBit(TCOK) == 1){		// once TCOK goes high, TC has been a success
				ClearBit(TCALLOW);	// disable the TC from moving
				Delay_sec(0.2);		// Brief timeout needed to avoid phantom e-stop due to TCOK PLC output relay bouncing
				ClearBit(TCACTIVE);		// and clear the bit telling the world we're in a TC
				printf("clear TCACTIVE (TC success)\n");
				ThreadDone();				// then kill the thread as it's done it's job
			}
			if(changeTO < Time_sec()){	// have we timed out?
				ClearBit(TCALLOW);			// then we'll stop the changer
				int Answer = MsgBox("Tool change failed. Retry?",MB_YESNO|MB_ICONEXCLAMATION);
				if (Answer == IDYES){			// if yes
					changeTO = Time_sec + 4;	// reset the time out
					SetBit(TCALLOW);			// reenable the TC and wait to see if it relocks
				} else {						// else we're going to estop everything
					ClearBit(SYSTEMOK);			// by clearing the SYSTEMOK bit (the estop script will handle killing everything)
					printf("TC abandoned by user after change failed\n");
					ThreadDone();					// and then we'll kill the thread as nothing more can happen
				}
			}
		}
	} else {
		// tools match, so we don't need to do anything
	}
}

main()
{

}
