#include "KMotionDef.h"
#include "cyclone.h"
#include "KflopToKMotionCNCFunctions.c"

#define Xaxis 0

main()
{
	int	FixtureIndex, Units, TWORD, HWORD, DWORD;
	double NewToolOffset,OriginOffsetX,AxisOffsetX;
	double Machinex,Machiney,Machinez,Machinea,Machineb,Machinec;
	float XEntered;
	
	// get the current Units and ToolTblID (and ignore the H and D Words)
	GetMiscSettings(&Units, &TWORD, &HWORD, &DWORD);
	
	// if KMotionCNC is in inch/G20 mode, then quit as it shouldn't be
	if(Units == CANON_UNITS_INCHES){
		MsgBox("KMotion set to inches. Set to MM and retry",MB_OK|MB_ICONEXCLAMATION);
		ThreadDone();
	}
	
	GetFixtureIndex(&FixtureIndex);
	
	GetOriginOffset(&OriginOffsetX, FixtureIndex, Xaxis);
	
	GetAxisOffset(&AxisOffsetX, Xaxis);
	
	GetMachine(&Machinex,&Machiney,&Machinez,&Machinea,&Machineb,&Machinec);
	
	// ask the operator for the actual size
	int Answer = InputBox("Enter measured diameter in MM",&XEntered);
	printf("Entered Value-%f\n",XEntered);
	if(Answer) {	// if true/1, then user cancelled
		MsgBox("X Offset adjustment cancelled",MB_OK|MB_ICONEXCLAMATION);
		ThreadDone;		// and kill the thread
	} else { // else we got a value and need to do some calcs
		// then the new offset with some rounding
		NewToolOffset = RoundToReasonable(Machinex - OriginOffsetX - AxisOffsetX - XEntered,Units);
		printf("X New Offset-%f\n",NewToolOffset);
		// and finally update the tool table
		printf("Setting new tool length\n");
		SetToolOffsetX(TWORD, NewToolOffset);
	}
}
