#include "KMotionDef.h"
#include "cyclone.h"
#include "KflopToKMotionCNCFunctions.c"

#define Zaxis 2

main()
{
	int	FixtureIndex, Units, TWORD, HWORD, DWORD;
	double NewToolLength,OriginOffsetZ,AxisOffsetZ;
	double Machinex,Machiney,Machinez,Machinea,Machineb,Machinec;
	float ZEntered;
	
	// get the current Units and ToolTblID (and ignore the H and D Words)
	GetMiscSettings(&Units, &TWORD, &HWORD, &DWORD);
	
	// if KMotionCNC is in inch/G20 mode, then quit as it shouldn't be
	if(Units == CANON_UNITS_INCHES){
		MsgBox("KMotion set to inches. Set to MM and retry",MB_OK|MB_ICONEXCLAMATION);
		ThreadDone();
	}
	
	GetFixtureIndex(&FixtureIndex);
	
	GetOriginOffset(&OriginOffsetZ, FixtureIndex, Zaxis);
	
	GetAxisOffset(&AxisOffsetZ, Zaxis);
	
	GetMachine(&Machinex,&Machiney,&Machinez,&Machinea,&Machineb,&Machinec);
	
	// ask the operator for the actual size
	int Answer = InputBox("Enter Z offset in MM",&ZEntered);
	printf("ZEntered-%f\n",ZEntered);
	if(Answer) {	// if true/1, then user cancelled
		MsgBox("Z Offset adjustment cancelled",MB_OK|MB_ICONEXCLAMATION);
		ThreadDone();		// and kill the thread
	} else { // else we got a value and need to do some calcs
		// then the new offset with some rounding
		NewToolLength = RoundToReasonable(Machinez - OriginOffsetZ - AxisOffsetZ - ZEntered,Units);
		printf("Z New Offset-%f\n",NewToolLength);
		// and finally update the tool table
		printf("Setting new tool length\n");
		SetToolLength(TWORD, NewToolLength);
		printf("New tool length set\n");
	}
}
