#include "KMotionDef.h"
#include "cyclone.h"
#include "KflopToKMotionCNCFunctions.c"
#include "Cyclone_ToolChange.c"

enum tcrstatus {TRGETPOS, TRVALIDPOS, TRCOMPLETE};

main()
{
	int curPos = persist.UserData[TCPOS];
	int desPos = persist.UserData[TCDES];
	int newPos = persist.UserData[TCNEW];
	float attemptPos;
	int newPos;
	int recStat = TRGETPOS;
	int recoverySucces = 0;
	int Answer;
	
	while(recStat != TRCOMPLETE){	//while we've not succesfully recovered, keep looping
		// is the TC reporting a valid actual position?
		if(recStat == TRGETPOS) {	// ask operator for position to attempt recovery to
			Answer = InputBox("Enter postion to attempt change (1-6)",&attemptPos);
			if(Answer) {	// if true/1, then user cancelled
				Answer = MsgBox("Tool Changer Recovery cancelled",MB_OK|MB_ICONEXCLAMATION);	// we use an answer to block the program until the user OKs
				ThreadDone();		// and kill the thread
			} else {		// else we got a value
				// cast and validate entered value
				newPos = attemptPos;
				printf("Requested Recovery Position - %d", newPos);
				if((newPos < 1) || (newPos > 6)){
					Answer = MsgBox("Invalid postion entered, re-enter?",MB_YESNO|MB_ICONEXCLAMATION);
					if(Answer == IDYES){
						// if true, we do nothing as we'll loop back to the start
					} else {
						Answer = MsgBox("Tool Changer Recovery cancelled",MB_OK|MB_ICONEXCLAMATION);	// we use an answer to block the program until the user OKs
						ThreadDone();	// and set the flag to break the loop and end the program
					}
				} else { //we have a valid value
					recStat = TRVALIDPOS;	// so set the next flag
				}
				
			}
		}
		if(recStat == TRVALIDPOS){	// we have had a valid position entered
			printf("Recovery new position - %d\n", newPos);
			persist.UserData[TCNEW] = newPos;		// update persist variable with new position
			doToolChange();							// and then simply command a toolchange
			// if we get back here (i.e. doToolChange hasn't killed the thread) the recovery should of been succesful
			// so we'll do a bit danity checking just to make sure..
			if((persist.UserData[TCPOS] == persist.UserData[TCDES]) && ReadBit(TCOK)){
				ClearBit(INIT);	// and all being good, we can clear the INIT virtual bit
				Answer = MsgBox("Tool Changer Recovery successful.",MB_OK|MB_ICONEXCLAMATION);
				ThreadDone();
			} else {
				// we should never get here, but just in case
				Answer = MsgBox("Tool Changer Recovery Failed",MB_OK|MB_ICONEXCLAMATION);
				ThreadDone();
			}
			
		}
	}
}
