#include "KMotionDef.h"
#include "cyclone.h"

//Plugin calls for Mach3 Home (actually Purge) Commands
//Called from Mach3 "REF" command
//in this case just Zero the measured position (encoder)
//and set the commanded destination to zero

#define X 0
//#define Y 1
#define Z 1

#define XHOME 142			// OptoIn 6  - high when proximity switch activated
#define XINDEX 36			// Ch5 Differential
#define ZHOME 143
#define ZINDEX 37
#define INHOMING 63			// set when we're in homing

main()
{
	int flags = persist.UserData[5];  // Mach3 flags bit0=X, bit1=Y, Bit2=Z, etc...

	printf("Mach3 Home Call, flags = %d\n",flags); 
	SetBit(INHOMING);
	if (flags & 1)
	{
		Jog(X,100000);          	// start moving
		while (!ReadBit(XHOME)) ; 	// wait for switch (input #15) to change
		Jog(X,0);		      	// StopMotion
		
		while(!CheckDone(X)) ;
		
		Jog(X,-5000);          	// start moving
		while (ReadBit(XHOME)) ; 	// wait for switch (input #15) to change
		Jog(X,0);		      	// StopMotion
		
		while(!CheckDone(X));

		Jog(X,-2000);          	// start moving
		while (!ReadBit(XINDEX)) ; 	// wait for switch (input #15) to change
		Jog(X,0);		      	// StopMotion

		while(!CheckDone(X)) ;
		Delay_sec(.25);
		
		DisableAxis(X);
		Zero(X);
		EnableAxisDest(X,0.0);
	}
	/*if (flags & 2)
	{
		DisableAxis(Y);
		Zero(Y);
		EnableAxisDest(Y,0.0);
	}*/
	if (flags & 4)
	{
		Jog(Z,80000);          	// start moving
		while (!ReadBit(ZHOME)) ; 	// wait for switch (input #15) to change
		Jog(Z,0);		      	// StopMotion
		
		while(!CheckDone(Z)) ;

		Jog(Z,-5000);          	// start moving
		while (ReadBit(ZHOME)) ; 	// wait for switch (input #15) to change
		Jog(Z,0);		      	// StopMotion
		
		while(!CheckDone(Z));
		
		Jog(Z,-2000);          	// start moving
		while (!ReadBit(ZINDEX)) ; 	// wait for switch (input #15) to change
		Jog(Z,0);		      	// StopMotion

		while(!CheckDone(Z)) ;
		Delay_sec(.25);
		
		DisableAxis(Z);
		Zero(Z);
		EnableAxisDest(Z,0.0);
	}
	
	ClearBit(INHOMING);
}
