#include "KMotionDef.h"
#include "cyclone.h"
#include "KflopToKMotionCNCFunctions.c"

#define HOMINGAXIS 1		// axis channel to home - Change this for each axis file (0=X, 1=Z)

main()
{
	printf("Homing Call"); 
	SetBit(INHOMING);
	int homeSwitch, index,axisHomed;
	
	// configure required inputs for selected axis
	if (HOMINGAXIS == 0){
		homeSwitch = XHOME;
		index = XINDEX;
		axisHomed = XHOMED;
		ch0->SoftLimitNeg = -1e+09;	// disable soft limits
		ch0->SoftLimitPos = 1e+09;
	} else if (HOMINGAXIS == 1){
		homeSwitch = ZHOME;
		index = ZINDEX;
		axisHomed = ZHOMED;
		ch1->SoftLimitNeg = -1e+09;
		ch1->SoftLimitPos = 1e+09;
	} else {
		int Answer = MsgBox("Invalid Axis selected for homing",MB_YESNO|MB_ICONEXCLAMATION);
		ThreadDone;
	}
	
	Jog(HOMINGAXIS,80000);          	// start moving
	while (!ReadBit(homeSwitch)) ; 	// wait for switch (input #15) to change
	Jog(HOMINGAXIS,0);		      	// StopMotion
	
	while(!CheckDone(HOMINGAXIS)) ;
	
	Jog(HOMINGAXIS,-5000);          	// start moving
	while (ReadBit(homeSwitch)) ; 	// wait for switch (input #15) to change
	Jog(HOMINGAXIS,0);		      	// StopMotion
	
	while(!CheckDone(HOMINGAXIS));

	Jog(HOMINGAXIS,-2000);          	// start moving
	while (!ReadBit(index)) ; 	// wait for switch (input #15) to change
	Jog(HOMINGAXIS,0);		      	// StopMotion

	while(!CheckDone(HOMINGAXIS)) ;
	Delay_sec(.25);
		
	DisableAxis(HOMINGAXIS);
	Zero(HOMINGAXIS);
	EnableAxisDest(HOMINGAXIS,0.0);
	
	if(HOMINGAXIS == 0){
		ch0->SoftLimitNeg = XSOFTNEG;
		ch0->SoftLimitPos = XSOFTPOS;
	}
	if(HOMINGAXIS == 1){
		ch1->SoftLimitNeg = ZSOFTNEG;
		ch1->SoftLimitPos = ZSOFTPOS;
	}
	
	SetBit(axisHomed);
	ClearBit(INHOMING);
}
